  package require critcl

  critcl::cproc noop {} void {}

  critcl::cproc add {int x int y} int {
    return x + y;
  }

  critcl::cproc cube {int x} int {
    return x * x * x;
  }

  puts "add 123 456 : [add 123 456]"

  catch {add 1} err;      puts "add 1       : $err"
  catch {add 1 2 3} err;  puts "add 1 2 3   : $err"
  catch {add 0 zero} err; puts "add 0 zero  : $err"

  proc sum {a b} { return [expr {$a+$b}] }
  proc pow3 {a} { return [expr {$a*$a*$a}] }

  proc ntimes {n cmd t} {
    set on $n
    set r {}
    while {[incr n -1] >= 0} { lappend r $cmd }
    set v [uplevel 1 [list time [join $r {; }] $t]]
    return [lreplace $v 0 0 [expr {[lindex $v 0]/(1.0*$on)}]]
  }

  puts ""
  puts "Tcl noop:  [ntimes 100 {} 1000]"
  puts "  C noop:  [ntimes 100 {noop} 1000]"

  set a 1
  set b 2
  puts ""
  puts "Tcl expr:  [ntimes 100 {expr {1+2}} 1000]"
  puts "Tcl vars:  [ntimes 100 {expr {$a+$b}} 1000]"
  puts "Tcl  sum:  [ntimes 100 {sum 1 2} 1000]"
  puts "  C  add:  [ntimes 100 {add 1 2} 1000]"
  puts "  C vars:  [ntimes 100 {add $a $b} 1000]"
  puts ""
  puts "Tcl expr:  [ntimes 100 {expr {2*2*2}} 1000]"
  puts "Tcl vars:  [ntimes 100 {expr {$b*$b*$b}} 1000]"
  puts "Tcl pow3:  [ntimes 100 {pow3 2} 1000]"
  puts "  C cube:  [ntimes 100 {cube 2} 1000]"
  puts "  C vars:  [ntimes 100 {cube $b} 1000]"
